## blktrace 0~git

=== Makefile ===
CC	= gcc
CFLAGS	= -Wall -O2 -g -W
ALL_CFLAGS = $(CFLAGS) -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
PROGS	= blkparse blktrace verify_blkparse blkrawverify
LIBS	= -lpthread
SCRIPTS	= btrace

all: $(PROGS) $(SCRIPTS)
	$(MAKE) -C btt

%.o: %.c
	$(CC) -o $*.o -c $(ALL_CFLAGS) $<

blkparse: blkparse.o blkparse_fmt.o rbtree.o act_mask.o
	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)

blktrace: blktrace.o act_mask.o $(LIBS)
	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)

verify_blkparse: verify_blkparse.o
	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)

blkrawverify: blkrawverify.o
	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)

$(PROGS): | depend

docs:
	$(MAKE) -C doc all
	$(MAKE) -C btt docs

docsclean:
	$(MAKE) -C doc clean
	$(MAKE) -C btt clean

depend:
	@$(CC) -MM $(ALL_CFLAGS) *.c 1> .depend

INSTALL = install
prefix = /usr/local
bindir = $(prefix)/bin
RPMBUILD = rpmbuild
TAR = tar

export prefix INSTALL TAR

dist: btrace.spec
	git-tar-tree HEAD btrace-1.0 > btrace-1.0.tar
	@mkdir -p btrace-1.0
	@cp btrace.spec btrace-1.0
	$(TAR) rf btrace-1.0.tar btrace-1.0/btrace.spec
	@rm -rf btrace-1.0
	@bzip2 btrace-1.0.tar

rpm: dist
	$(RPMBUILD) -ta btrace-1.0.tar.bz2

clean: docsclean
	-rm -f *.o $(PROGS) .depend btrace-1.0.tar.bz2
	$(MAKE) -C btt clean

install: $(PROGS) $(SCRIPTS)
	$(INSTALL) -m755 -d $(DESTDIR)$(bindir)
	$(INSTALL) $(PROGS) $(SCRIPTS) $(DESTDIR)$(bindir)
	$(INSTALL) btt/btt $(DESTDIR)$(bindir)

ifneq ($(wildcard .depend),)
include .depend
endif

=== btt/Makefile ===
CC	= gcc
CFLAGS	= -Wall -O2 -W -g
# CFLAGS	= -Wall -g -W -UDO_INLINE -DDEBUG
ALL_CFLAGS = $(CFLAGS) -I.. -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
PROGS	= btt
#ELIBS	= -lefence
#PLIBS	= -lpthread
LIBS	= $(PLIBS) $(ELIBS)
OBJS	= args.o bt_timeline.o devmap.o devs.o dip_rb.o iostat.o latency.o \
	  misc.o output.o proc.o seek.o trace.o trace_complete.o trace_im.o \
	  trace_issue.o trace_queue.o trace_remap.o trace_requeue.o rbtree.o \
	  mmap.o trace_plug.o

all: depend $(PROGS)

rbtree.o: ../rbtree.c
	$(CC) -o $*.o -c $(ALL_CFLAGS) $<

depend:
	@$(CC) -MM $(ALL_CFLAGS) -I.. *.c 1> .depend

clean: docsclean
	-rm -f *.o $(PROGS) .depend

%.o: %.c
	$(CC) -o $*.o -c $(ALL_CFLAGS) $<

btt: $(OBJS)
	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)

docs:
	$(MAKE) -C doc all

docsclean:
	$(MAKE) -C doc clean

ifneq ($(wildcard .depend),)
include .depend
endif

=== doc/Makefile ===
DOCTMP	= blktrace.log blktrace.aux blktrace.dvi

all: blktrace.pdf

blktrace.tex:
	@touch blktrace.tex

blktrace.pdf: blktrace.tex
	@latex blktrace.tex > /dev/null
	@latex blktrace.tex > /dev/null
	@dvipdfm -p a4 blktrace
	@rm -rf $(DOCTMP)

clean:
	-rm -f blktrace.pdf $(DOCTMP)

## blktrace 0.99.3+git

=== Makefile ===
--- 
+++ 
@@ -5,8 +5,19 @@
 LIBS	= -lpthread
 SCRIPTS	= btrace
 
-all: $(PROGS) $(SCRIPTS)
+ALL = $(PROGS) $(SCRIPTS) btt/btt btreplay/btrecord btreplay/btreplay \
+      btt/bno_plot.py
+
+all: $(ALL)
+
+btt/btt:
 	$(MAKE) -C btt
+
+btreplay/btrecord:
+	$(MAKE) -C btreplay
+
+btreplay/btreplay:
+	$(MAKE) -C btreplay
 
 %.o: %.c
 	$(CC) -o $*.o -c $(ALL_CFLAGS) $<
@@ -14,7 +25,7 @@
 blkparse: blkparse.o blkparse_fmt.o rbtree.o act_mask.o
 	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)
 
-blktrace: blktrace.o act_mask.o $(LIBS)
+blktrace: blktrace.o act_mask.o
 	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)
 
 verify_blkparse: verify_blkparse.o
@@ -28,10 +39,12 @@
 docs:
 	$(MAKE) -C doc all
 	$(MAKE) -C btt docs
+	$(MAKE) -C btreplay docs
 
 docsclean:
 	$(MAKE) -C doc clean
 	$(MAKE) -C btt clean
+	$(MAKE) -C btreplay clean
 
 depend:
 	@$(CC) -MM $(ALL_CFLAGS) *.c 1> .depend
@@ -39,6 +52,7 @@
 INSTALL = install
 prefix = /usr/local
 bindir = $(prefix)/bin
+mandir = $(prefix)/man
 RPMBUILD = rpmbuild
 TAR = tar
 
@@ -58,11 +72,15 @@
 clean: docsclean
 	-rm -f *.o $(PROGS) .depend btrace-1.0.tar.bz2
 	$(MAKE) -C btt clean
+	$(MAKE) -C btreplay clean
 
-install: $(PROGS) $(SCRIPTS)
-	$(INSTALL) -m755 -d $(DESTDIR)$(bindir)
-	$(INSTALL) $(PROGS) $(SCRIPTS) $(DESTDIR)$(bindir)
-	$(INSTALL) btt/btt $(DESTDIR)$(bindir)
+install: all
+	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)
+	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man1
+	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man8
+	$(INSTALL) -m 755 $(ALL) $(DESTDIR)$(bindir)
+	$(INSTALL) -m 644 doc/*.1 $(DESTDIR)$(mandir)/man1
+	$(INSTALL) -m 644 doc/*.8 $(DESTDIR)$(mandir)/man8
 
 ifneq ($(wildcard .depend),)
 include .depend

=== btreplay/Makefile ===
#
# OCFLAGS:
# 	COUNT_IOS	- Counts struct io's left at end
# 	DEBUG		- Various and sundy debug asserts
# 	NDEBUG		- Defined: no asserts, Undefined: asserts
#

CC	= gcc
CFLAGS	= -Wall -W -O2 -g
INCS	= -I. -I.. -I../btt
OCFLAGS	= -UCOUNT_IOS -UDEBUG -DNDEBUG
XCFLAGS	= -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
override CFLAGS += $(INCS) $(XCFLAGS) $(OCFLAGS)

PROGS	= btrecord btreplay
LIBS	= -laio -lrt

all: depend $(PROGS)

$(PROGS): | depend

docs:
	$(MAKE) -C doc all

docsclean:
	$(MAKE) -C doc clean

clean: docsclean
	-rm -f *.o $(PROGS) .depend

%.o: %.c
	$(CC) $(CFLAGS) -c -o $*.o $<

btrecord: btrecord.o
	$(CC) $(CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)

btreplay: btreplay.o
	$(CC) $(CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)

depend:
	@$(CC) -MM $(CFLAGS) *.c 1> .depend

ifneq ($(wildcard .depend),)
include .depend
endif

=== btt/Makefile ===
#
# OCFLAGS:
# 	COUNT_IOS	- Counts struct io's left at end
# 	DEBUG		- Various and sundy debug asserts
# 	NDEBUG		- Defined: no asserts, Undefined: asserts
#

CC	= gcc
CFLAGS	= -Wall -W -O2 -g
INCS	= -I. -I..
OCFLAGS	= -UCOUNT_IOS -UDEBUG -DNDEBUG
XCFLAGS	= -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
override CFLAGS += $(INCS) $(XCFLAGS) $(OCFLAGS)

PROGS	= btt
LIBS	= $(PLIBS) $(ELIBS)
OBJS	= args.o bt_timeline.o devmap.o devs.o dip_rb.o iostat.o latency.o \
	  misc.o output.o proc.o seek.o trace.o trace_complete.o trace_im.o \
	  trace_issue.o trace_queue.o trace_remap.o trace_requeue.o \
	  ../rbtree.o mmap.o trace_plug.o bno_dump.o unplug_hist.o q2d.o

all: depend $(PROGS)

.PHONY : depend
depend: $(patsubst %.o,%.c,$(filter %.o,$(OBJS)))
	@$(CC) -MM $(CFLAGS) -I.. $^ 1> .depend

docs:
	$(MAKE) -C doc all

docsclean:
	$(MAKE) -C doc clean

clean: docsclean
	-rm -f *.o $(PROGS) .depend

%.o: %.c
	$(CC) $(CFLAGS) -c -o $*.o $<

btt: $(OBJS)
	$(CC) $(CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)

ifneq ($(wildcard .depend),)
include .depend
endif

=== btt/doc/Makefile ===
DOCTMP	= btt.log btt.aux btt.dvi btt.toc

all: btt.pdf

btt.tex: activity.eps qhist.eps dhist.eps seek.eps
	@touch btt.tex

btt.pdf: btt.tex
	@latex btt.tex
	@latex btt.tex
	@dvipdfm -p a4 btt
	@rm -rf $(DOCTMP)

clean:
	-rm -f btt.pdf $(DOCTMP)

## blktrace 1.0.5

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CC	= gcc
 CFLAGS	= -Wall -O2 -g -W
 ALL_CFLAGS = $(CFLAGS) -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
-PROGS	= blkparse blktrace verify_blkparse blkrawverify
+PROGS	= blkparse blktrace verify_blkparse blkrawverify blkiomon
 LIBS	= -lpthread
 SCRIPTS	= btrace
 
@@ -33,6 +33,9 @@
 
 blkrawverify: blkrawverify.o
 	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)
+
+blkiomon: blkiomon.o rbtree.o
+	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^) $(LIBS) -lrt
 
 $(PROGS): | depend

=== debian/changelog ===
blktrace (1.0.5-1) unstable; urgency=low

  * New upstream release [February 2012].
  * Copyright to copyright-format-1.0 & update.
  * Source to 3.0 (quilt) format + xz compression.
    - dropped "patch" from Build-Depends.
  * Debhelper & compat to version 9; standards to 3.9.4.
  * Updated runlevels (Closes: #541867) thanks, Petter Reinholdtsen.
  * mountdebugfs.init:
    + added LSB Description.
    + added LSB dependency "$remote_fs".
    + updated runlevels; make stop in runlevel 1 explicit.
  * Patchworks:
    - Dropped 20_no-add-needed.patch (applied-upstream).
    + New patch to fix spelling and hyphens.
    + 10_btrace_paths.patch is updated, DEP-3 headers added.
  * Simplified debian/rules.
  * Removed obsolete entries from debian/dirs.
  * Build with default Hardening flags.
  * xz compression for binary package.
  * Architecture changed to "linux-any".
  * Install upstream README file.
  * Added myself to Uploaders.
  * Added VCS links to new collab-maint repository.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 05 May 2013 22:42:58 +1000

blktrace (1.0.1-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS with binutils-gold": add patch from Ubuntu / Ilya Barygin:
    - New patch 20_no-add-needed.patch: add missing library to fix linking
      failure
    (Closes: #553968)

 -- gregor herrmann <gregoa@debian.org>  Sat, 17 Dec 2011 15:40:06 +0100

blktrace (1.0.1-2) unstable; urgency=low

  * Move package from optional to extras because of its dependency on libaoi

 -- Bas Zoetekouw <bas@debian.org>  Tue, 30 Jun 2009 19:01:26 +0200

blktrace (1.0.1-1) unstable; urgency=low

  * New upstream release
    - patches 16_bnoplot_man.patch, 17_btrecord_linking.patch, and
      18_man_section.patch have been merged upstream.
  * This is a real release, not a git snapshot, we we're not calling git-log
    at build any more, so remove build-dep on git-core (closes: #516062)
  * Added an upstream changelog (git log output)
  * Bumped Standards-version to 3.8.2:
    - Added upstream Homepage to control file
  * Replace build-dep on gs-gpl|gs by ghostscript

 -- Bas Zoetekouw <bas@debian.org>  Mon, 29 Jun 2009 16:47:14 +0200

blktrace (0.99.3+git-20080213182518-1) unstable; urgency=low

  * New upstream release:
    - Added man pages for btreplay and btrecord 
      [obsoletes 15_btreplay_man.patch]
    - Separated out g/i/m trace handling and DM-device calculations
    - Fix Q counts during requeue and merges
    - Fixed excess bucket information for unplug histograms
    - Fixed double inforation about timeouts
    - Added new IOs per unplug table
    - Added bno_plot plot utility
    - Fix iostat interval default
    - Fix missing cleanup calls
    - Fixed IOPs in btt left over at end of run
  * Renamed bno_plot.py to bno_plot
  * Added suggests on gnuplot-x11 (bno_plot needs it)
  * Added suggests on python (bno_plot needs it)
  * Added man page for bno_plot 
    [16_bnoplot_man.patch]
  * Added information about which Debian kernels have CONFIG_BLK_DEV_IO_TRACE
    set to the long description.
  * Automatically mount debugfs on boot (add init script)
  * Depend on lsb-base (for init script functions)
  * Don't link btrecord against libaio and librt
  * Increase Standards-Version to 3.7.3 (no changes necessary)


 -- Bas Zoetekouw <bas@debian.org>  Fri, 22 Feb 2008 11:08:38 +0100

blktrace (0.99.3+git-20071207142532-1) unstable; urgency=low

  * New upstream release:
      - Fix compilation on m68k 
        [obsoletes 13_m68k_barrier.patch]
      - Sync btt manpages with TeX docs
        [obsoletes 14_btt_man.patch]
      - Add btrecord and btreplay programs
      - Fix warnings from gcc-4.2.1
      - Fix several segfaults
      - Added O_NOATIME to replay file
      - Fixed REMAP to update Q2A & fixed #Q calculations
      - Added active requests at Q information.
      - memset() must be done after NULL check
      - Added in Q2D histograms (requires -A)
      - Remove strange make dependency on "-lpthread"
  * Follow upstream version numbering
  * Updated debian/watch to follow new version numbering
  * Added manpages for btrecord and btreplay
    [15_btreplay_man.patch]
  * Mention enabling of CONFIG_BLK_DEV_IO_TRACE in linux-2.6/2.6.23-1 in
    README.Debian
  * Remove obsolete build-dependency on linux-kernel-headers
  * Add build-dependency on libaio-dev

 -- Bas Zoetekouw <bas@debian.org>  Sat, 08 Dec 2007 13:32:55 +0100

blktrace (0~git-20070910192508-1) unstable; urgency=low

  * New upstream release:
    - Added man pages
    - Misc minor fixes to Makefiles
      [obsoletes 12_Makefile_INCS.patch]
    - Major revamping of btt: 
      - major performance boost 
      - added Q2Q seek distance feature
  * Merge changes in btt man page from version 0~git-20070718142546-1
    [14_btt_man.patch]
  * Change compiler flags to "-Wall -Wextra -Wno-shadow"
  * Fix installation path for man pages

 -- Bas Zoetekouw <bas@debian.org>  Sat, 29 Sep 2007 18:43:26 +0200

blktrace (0~git-20070718142546-2) unstable; urgency=low

  * Fix detection of m68k in barrier.h [13_m68k_barrier.patch] 

 -- Bas Zoetekouw <bas@debian.org>  Sat, 04 Aug 2007 12:03:44 +0200

blktrace (0~git-20070718142546-1) unstable; urgency=low

  * New upstream release:
    - Added store barrier defines for a bunch of archs
    - Fixed several memleaks
    - Added seek absolute option
    - Added block number dumping
    - Output combined seeks in addition to read and write seeks
    - Added in unplug IO count histogram
    - Added-r support for btrace
    - Fix crash with '-' stdin input
    - Fix queued vs dispatch numbers
    - Account size of merges
  * Remove 11_barrier_wmb.patch, which was merged upstream
  * Install an upstream changelog (and build-depend on git-core to create it)
  * Fixed btt man page wrt changes in upstream source
  * Fixed debian-watch to not trigger on blktrace-git-latest.tar.gz (for real,
    this time)
  * Fixed the Makesfile for btt to work with externally set $CFLAGS


=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

#DEB_BUILD_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS  )

CFLAGS += -Wall -Wextra -Wno-shadow -g

PKGNAME    :=$(word 2,$(shell dpkg-parsechangelog | grep ^Source  ) )
FULLVERSION:=$(word 2,$(shell dpkg-parsechangelog | grep ^Version ) )
UPSTREAMVER:=$(shell echo $(FULLVERSION) | sed 's/-[0-9.]\+$$//' | sed 's/^0~//' )

%:
	dh $@

override_dh_auto_build:
ifeq ($(DEB_BUILD_ARCH_OS),linux)
	# Building for a Linux-type OS, everything's fine
	#
	# variables are:
	# PKGNAME      $(PKGNAME)
	# FULLVERSION  $(FULLVERSION)
	# UPSTREAMVER  $(UPSTREAMVER)
else
	####################################################
	## Oops, it seems you are trying to build blkutils
	## for a non-Linux OS `$(DEB_BUILD_ARCH_OS)'.
	## This is not supported.
	## Please file a bug if you think this is wrong.
	####################################################
	false
endif
	$(MAKE) CFLAGS="$(CPPFLAGS) $(CFLAGS) $(LDFLAGS)" all docs

override_dh_auto_install:
	$(MAKE) install \
		prefix=/usr \
		mandir=\$${prefix}/share/man \
		DESTDIR=$(CURDIR)/debian/$(PKGNAME)
	# move admin-only stuff to /usr/sbin
	cd $(CURDIR)/debian/$(PKGNAME) && \
		mv usr/bin/btrace    usr/sbin/ && \
		mv usr/bin/blktrace  usr/sbin/ && \
		mv usr/bin/btreplay  usr/sbin/ && \
		mv usr/bin/btrecord  usr/sbin/ 
	# fix name of bno_plot
	cd $(CURDIR)/debian/$(PKGNAME) && \
		mv usr/bin/bno_plot.py usr/bin/bno_plot

override_dh_installinit:
	dh_installinit --name=mountdebugfs --no-restart-on-upgrade

override_dh_compress:
	dh_compress -X.pdf

override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
version=3
opts=dversionmangle=s/^[0-9.]+\+// \
http://brick.kernel.dk/snaps/ \
	blktrace-((?!git-latest).+?)\.tar\.gz \
	debian

## blktrace 1.1.0

=== Makefile ===
--- 
+++ 
@@ -6,12 +6,15 @@
 SCRIPTS	= btrace
 
 ALL = $(PROGS) $(SCRIPTS) btt/btt btreplay/btrecord btreplay/btreplay \
-      btt/bno_plot.py
+      btt/bno_plot.py iowatcher/iowatcher
 
 all: $(ALL)
 
 btt/btt:
 	$(MAKE) -C btt
+
+iowatcher/iowatcher:
+	$(MAKE) -C iowatcher
 
 btreplay/btrecord:
 	$(MAKE) -C btreplay

=== debian/changelog ===
blktrace (1.1.0-2+deb9u1ubuntu0.16.04.1) xenial; urgency=medium

  * Fix failure when CPUs are offline (LP: #1827318)
    If one or more CPUs are offline then currently blktrace breaks
    because it detects the number of CPUs based on the number of
    CPUs rather than the number of online CPUs. Requires two upstream
    blktrace fixes to fully address this issue
    - 80c4041b2e7a7d5 ("blktrace: Use number of online CPUs")
    - d045a704a378b90 ("blktrace: Add support for sparse CPU numbers")

 -- Colin Ian King <colin.king@canonical.com>  Wed, 22 May 2019 13:22:31 +0100

blktrace (1.1.0-2+deb9u1build0.16.04.1) xenial-security; urgency=medium

  * fake sync from Debian

 -- Mike Salvatore <mike.salvatore@canonical.com>  Fri, 26 Oct 2018 11:40:22 -0400

blktrace (1.1.0-2+deb9u1) stretch; urgency=high

  * Fix buffer overflow in btt (CVE-2018-10689) (Closes: #897695)

 -- Bas Zoetekouw <bas@debian.org>  Wed, 16 May 2018 16:19:54 +0200

blktrace (1.1.0-2) unstable; urgency=low

  * Upload to unstable.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 17 May 2015 22:35:02 +1000

blktrace (1.1.0-1) experimental; urgency=low

  * New upstream release [September 2014].
    + Install new binary `iowatcher` (Closes: #729204).
      "iowatcher" became part of "blktrace".
  * iowatcher-related changes:
    + Added "debian/blktrace.manpages" to install `iowatcher.1` man page.
    + Added "debian/clean" file.
    + Added "override_dh_installdocs" to install renamed iowatcher README.
    + Added paragraph describing iowatcher to long package description.
    + Recommends: [libtheora-bin, libav-tools, librsvg2-bin].
    + New patches: [ffmpeg2avconv.patch, man.patch, procnum.patch].
  * Modernise Vcs-Browser URL.
  * Standards-Version: 3.9.6.
  * Removed obsolete paragraph describing requirements for patched kernels
    earlier than 2.6.23 from long package description.
  * watch file update; tighten match pattern to exclude git snapshots.
  * Added "debian/gbp.conf".
  * Dropped obsolete "override_dh_builddeb".
  * Build with all hardening.
  * Copyright updates and corrections.
  * New "pdf-date.patch" to preserve date in "btreplay.pdf".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 25 Mar 2015 18:54:47 +1100

=== debian/control ===
Source: blktrace
Section: utils
Priority: extra
Maintainer: Bas Zoetekouw <bas@debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends:
    debhelper (>= 9),
    ghostscript,
    libaio-dev,
    texlive-latex-base,
    texlive-latex-extra
Standards-Version: 3.9.6
Homepage: http://brick.kernel.dk/snaps/
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/blktrace.git
Vcs-Git: git://anonscm.debian.org/collab-maint/blktrace.git

Package: blktrace
Architecture: linux-any
Depends: ${misc:Depends},
    ${shlibs:Depends},
    python,
    lsb-base
Recommends: libtheora-bin
           ,libav-tools
           ,librsvg2-bin
Suggests: gnuplot-x11
Description: utilities for block layer IO tracing
 blktrace is a block layer IO tracing mechanism which provides detailed
 information about request queue operations up to user space. There are
 three major components that are provided:
 .
 blktrace: A utility which transfers event traces from the kernel
 into either long-term on-disk storage, or provides direct formatted
 output (via blkparse).
 .
 blkparse: A utility which formats events stored in files, or when
 run in live mode directly outputs data collected by blktrace.
 .
 iowatcher: A utility to visualize block I/O patterns. It generates graphs
 from blktrace runs to help visualize IO patterns and performance. It can
 plot multiple blktrace runs together, making it easy to compare the
 differences between different benchmark runs.

=== debian/watch ===
version=3
opts=dversionmangle=s/^[0-9.]+\+// \
http://brick.kernel.dk/snaps/ \
    blktrace-(\d[\d.]+)\.tar\.(?:gz|xz|bz2)

## blktrace 1.2.0

=== Makefile ===
--- 
+++ 
@@ -79,6 +79,7 @@
 	-rm -f *.o $(PROGS) .depend btrace-1.0.tar.bz2
 	$(MAKE) -C btt clean
 	$(MAKE) -C btreplay clean
+	$(MAKE) -C iowatcher clean
 
 install: all
 	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)

=== btt/Makefile ===
--- 
+++ 
@@ -8,16 +8,16 @@
 CC	= gcc
 CFLAGS	= -Wall -W -O2 -g
 INCS	= -I. -I..
-OCFLAGS	= -UCOUNT_IOS -UDEBUG -DNDEBUG
 XCFLAGS	= -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
-override CFLAGS += $(INCS) $(XCFLAGS) $(OCFLAGS)
+override CFLAGS += $(INCS) $(XCFLAGS)
 
 PROGS	= btt
 LIBS	= $(PLIBS) $(ELIBS)
 OBJS	= args.o bt_timeline.o devmap.o devs.o dip_rb.o iostat.o latency.o \
 	  misc.o output.o proc.o seek.o trace.o trace_complete.o trace_im.o \
 	  trace_issue.o trace_queue.o trace_remap.o trace_requeue.o \
-	  ../rbtree.o mmap.o trace_plug.o bno_dump.o unplug_hist.o q2d.o
+	  ../rbtree.o mmap.o trace_plug.o bno_dump.o unplug_hist.o q2d.o \
+	  aqd.o plat.o rstats.o p_live.o
 
 all: depend $(PROGS)

=== btreplay/doc/Makefile ===
DOCTMP  = btreplay.log btreplay.aux btreplay.dvi btreplay.toc

all: btreplay.dvi btreplay.pdf

btreplay.tex:
	@touch btreplay.tex

btreplay.dvi: btreplay.tex abstract.tex
	@latex btreplay.tex
	@latex btreplay.tex

btreplay.pdf: btreplay.dvi
	@dvipdfm -p letter btreplay

clean:
	-rm -f $(DOCTMP)
	-rm -f *.bak *.ps *.pdf
	@rm -rf btreplay

=== debian/changelog ===
blktrace (1.2.0-5ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:38:50 +1100

blktrace (1.2.0-5ubuntu1) noble; urgency=medium

  * Build without -Werror=format-overflow, -Werror=format-truncation on 
    ppc64el where it misfires and causes a build failure.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 23 Mar 2024 02:17:48 +0000

blktrace (1.2.0-5build1) noble; urgency=medium

  * No-change rebuild against libaio1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 09:13:36 +0000

blktrace (1.2.0-5) unstable; urgency=low

  * Disable parallel builds (caused races like in
    https://buildd.debian.org/status/fetch.php?pkg=blktrace&arch=ppc64&ver=1.2.0-4&stamp=1550096425&raw=0)

 -- Bas Zoetekouw <bas@debian.org>  Sat, 23 Feb 2019 23:17:21 +0100

blktrace (1.2.0-4) unstable; urgency=low

  * Split and adjust gcc warnings patch

 -- Bas Zoetekouw <bas@debian.org>  Wed, 13 Feb 2019 22:19:54 +0100

blktrace (1.2.0-3) unstable; urgency=low

  * d/copyright: Change Format URL to correct one
  * change compat level to 11
  * update policy to 4.3.0
  * update homepage
  * update watch file to look at kernel git repo
  * extend DEB_BUILD_MAINT_OPTIONS
  * fix gcc warnings (including a possible buffer overflow)

 -- Bas Zoetekouw <bas@debian.org>  Tue, 12 Feb 2019 13:21:56 +0100

blktrace (1.2.0-2) unstable; urgency=medium

  * Remove unnecessary debian/blktrace.manpages file.  The upstream
    build system installs the manpage correctly by itself.
    (Closes: #903169)
  * Set Rules-Requires-Root to no as blktrace does not need
    (fake)root to create debs.

 -- Bas Zoetekouw <bas@debian.org>  Tue, 07 Aug 2018 15:54:17 +0200

blktrace (1.2.0-1) unstable; urgency=medium

  * New upstream release
  * Update VCS links to salsa.debian.org
  * Change SUggests from libav-tools to ffmpeg (Closes: #895915)
  * Update Standards-version to version 4.1.4; change priority to optional
  * Fix buffer overflow in btt (CVE-2018-10689) (Closes: #897695)
  * Fix FTCBFS: (Closes: #894836)
    + Let dh_auto_build pass cross tools to make.
    + Fix build/host confusion.
  * Make build reproducible
  * Fix typo in README.Debian
  * Don't parse changelog during build
  * Add doc-base metadata for documentation
  * Remove debugfs mounting init script, as systemd is moutning debugfs
    by default nowadays (Closes: #873470, #705269)
  * Add python3 support for btt_plot.py and bno_plot.py

 -- Bas Zoetekouw <bas@debian.org>  Sat, 19 May 2018 21:49:22 +0200

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

CFLAGS += -Wall -Wextra -Wno-shadow -Werror -g

export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+all qa=+all reproducible=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifeq ($(DEB_HOST_ARCH),ppc64el)
  export DEB_CFLAGS_MAINT_APPEND = -Wno-error=format-overflow -Wno-error=format-truncation
endif
# make sure TeX/dvipdfm generates reproducable builds
export FORCE_SOURCE_DATE=1

%:
	dh $@ --no-parallel

override_dh_auto_build:
ifeq ($(DEB_HOST_ARCH_OS),linux)
	# Building for a Linux-type OS, everything's fine
	#
	# variables are:
	# Package name      $(DEB_SOURCE)
	# Full version      $(FULLVERSION)
	# Upstream version  $(DEB_VERSION_UPSTREAM)
else
	####################################################
	## Oops, it seems you are trying to build blkutils
	## for a non-Linux OS `$(DEB_HOST_ARCH_OS)'.
	## This is not supported.
	## Please file a bug if you think this is wrong.
	####################################################
	false
endif
	dh_auto_build --no-parallel -- CFLAGS="$(CPPFLAGS) $(CFLAGS) $(LDFLAGS)" all docs

override_dh_auto_install:
	$(MAKE) install \
		prefix=/usr \
		mandir=\$${prefix}/share/man \
		DESTDIR=$(CURDIR)/debian/$(DEB_SOURCE)
	# move admin-only stuff to /usr/sbin
	cd $(CURDIR)/debian/$(DEB_SOURCE) && \
		mv usr/bin/btrace    usr/sbin/ && \
		mv usr/bin/blktrace  usr/sbin/ && \
		mv usr/bin/btreplay  usr/sbin/ && \
		mv usr/bin/btrecord  usr/sbin/
	# fix name of bno_plot
	cd $(CURDIR)/debian/$(DEB_SOURCE) && \
		mv usr/bin/bno_plot.py usr/bin/bno_plot

override_dh_compress:
	dh_compress -X.pdf

=== debian/watch ===
version=4
opts=dversionmangle=s/^[0-9.]+\+// \
    https://git.kernel.org/pub/scm/linux/kernel/git/axboe/blktrace.git/refs/ \
	/pub/scm/linux/kernel/git/axboe/blktrace.git/snapshot/blktrace-(\d[\d.]+).tar.gz

## blktrace 1.3.0

=== Makefile ===
--- 
+++ 
@@ -4,41 +4,37 @@
 PROGS	= blkparse blktrace verify_blkparse blkrawverify blkiomon
 LIBS	= -lpthread
 SCRIPTS	= btrace
+SUBDIRS = btreplay btt iowatcher
 
-ALL = $(PROGS) $(SCRIPTS) btt/btt btreplay/btrecord btreplay/btreplay \
+ALL = $(PROGS) $(SCRIPTS)
+INSTALL_ALL = $(ALL) btt/btt btreplay/btrecord btreplay/btreplay \
       btt/bno_plot.py iowatcher/iowatcher
 
-all: $(ALL)
+all: $(ALL) $(SUBDIRS)
 
-btt/btt:
-	$(MAKE) -C btt
-
-iowatcher/iowatcher:
-	$(MAKE) -C iowatcher
-
-btreplay/btrecord:
-	$(MAKE) -C btreplay
-
-btreplay/btreplay:
-	$(MAKE) -C btreplay
+# We always descend into subdirs because they contain their own dependency
+# information which we don't track in this top level Makefile.
+$(SUBDIRS): $(PROGS)
+	$(MAKE) -C $@
+.PHONY: $(SUBDIRS)
 
 %.o: %.c
 	$(CC) -o $*.o -c $(ALL_CFLAGS) $<
 
 blkparse: blkparse.o blkparse_fmt.o rbtree.o act_mask.o
-	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)
+	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^)
 
 blktrace: blktrace.o act_mask.o
-	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)
+	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^) $(LIBS)
 
 verify_blkparse: verify_blkparse.o
-	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)
+	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^)
 
 blkrawverify: blkrawverify.o
-	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^)
+	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^)
 
 blkiomon: blkiomon.o rbtree.o
-	$(CC) $(ALL_CFLAGS) -o $@ $(filter %.o,$^) $(LIBS) -lrt
+	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^) $(LIBS) -lrt
 
 $(PROGS): | depend
 
@@ -85,7 +81,7 @@
 	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)
 	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man1
 	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man8
-	$(INSTALL) -m 755 $(ALL) $(DESTDIR)$(bindir)
+	$(INSTALL) -m 755 $(INSTALL_ALL) $(DESTDIR)$(bindir)
 	$(INSTALL) -m 644 doc/*.1 $(DESTDIR)$(mandir)/man1
 	$(INSTALL) -m 644 doc/*.8 $(DESTDIR)$(mandir)/man8

=== btt/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	$(CC) $(CFLAGS) -c -o $*.o $<
 
 btt: $(OBJS)
-	$(CC) $(CFLAGS) -o $@ $(filter %.o,$^) $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^) $(LIBS)
 
 ifneq ($(wildcard .depend),)
 include .depend

=== doc/Makefile ===
--- 
+++ 
@@ -6,8 +6,8 @@
 	@touch blktrace.tex
 
 blktrace.pdf: blktrace.tex
-	@latex blktrace.tex > /dev/null
-	@latex blktrace.tex > /dev/null
+	@latex blktrace.tex
+	@latex blktrace.tex
 	@dvipdfm -p a4 blktrace
 	@rm -rf $(DOCTMP)

=== iowatcher/Makefile ===
CC      = gcc
CFLAGS  = -Wall -O2 -g -W -Wunused-result
ALL_CFLAGS = $(CFLAGS) -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

PROGS = iowatcher
INSTALL = install
prefix = /usr/local
bindir = $(prefix)/bin

export prefix INSTALL

ALL = $(PROGS)

$(PROGS): | depend

all: $(ALL)

%.o: %.c
	$(CC) -o $*.o -c $(ALL_CFLAGS) $<

iowatcher: blkparse.o plot.o main.o tracers.o mpstat.o fio.o
	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ $(filter %.o,$^) -lm -lrt

depend:
	@$(CC) -MM $(ALL_CFLAGS) *.c 1> .depend

clean:
	-rm -f *.o $(PROGS) .depend

install: all
	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)
	$(INSTALL) -m 755 $(ALL) $(DESTDIR)$(bindir)

ifneq ($(wildcard .depend),)
include .depend
endif

=== debian/changelog ===
blktrace (1.3.0-0.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Fukui Daichi ]
  * Add patch for build failure on mips64el and ppc64el (Closes: #1082328)

 -- Paul Gevers <elbrus@debian.org>  Wed, 23 Oct 2024 11:43:43 +0200

blktrace (1.3.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Remove 1 obsolete maintscript entry.
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Fix day-of-week for changelog entry 0~git-20061221162513-1.
  * Update standards version to 4.6.0, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Fukui Daichi ]
  * New upstream version 1.3.0 (Closes: #1073161)
  * Remove and fix patches to catch up with 1.3.0
  * Update d/copyright
    - Added more precise copyright information
  * Update standards version to 4.7.0, no changes needed.

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sat, 16 Sep 2023 03:17:24 +0000

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,27 @@
 Source: blktrace
 Section: utils
-Priority: extra
+Priority: optional
 Maintainer: Bas Zoetekouw <bas@debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends:
-    debhelper (>= 9),
+    debhelper-compat (= 13),
     ghostscript,
     libaio-dev,
     texlive-latex-base,
     texlive-latex-extra
-Standards-Version: 3.9.6
-Homepage: http://brick.kernel.dk/snaps/
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/blktrace.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/blktrace.git
+Standards-Version: 4.7.0
+Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/axboe/blktrace.git/about/
+Vcs-Browser: https://salsa.debian.org/debian/blktrace
+Vcs-Git: https://salsa.debian.org/debian/blktrace.git
+Rules-Requires-Root: no
 
 Package: blktrace
 Architecture: linux-any
-Depends: ${misc:Depends},
-    ${shlibs:Depends},
-    python,
-    lsb-base
+Depends: ${misc:Depends}
+    ,${shlibs:Depends}
+    ,python3
 Recommends: libtheora-bin
-           ,libav-tools
+           ,ffmpeg
            ,librsvg2-bin
 Suggests: gnuplot-x11
 Description: utilities for block layer IO tracing

=== debian/rules ===
--- 
+++ 
@@ -8,11 +8,7 @@
 CFLAGS += -Wall -Wextra -Wno-shadow -Werror -g
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+all qa=+all reproducible=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-ifeq ($(DEB_HOST_ARCH),ppc64el)
-  export DEB_CFLAGS_MAINT_APPEND = -Wno-error=format-overflow -Wno-error=format-truncation
-endif
 # make sure TeX/dvipdfm generates reproducable builds
 export FORCE_SOURCE_DATE=1
 
@@ -55,4 +51,3 @@
 
 override_dh_compress:
 	dh_compress -X.pdf
-
